function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get.bind(); } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/**
 * Copyright 2020 Tridium, Inc. All Rights Reserved.
 * @author James Johnson
 */

/**
 * API Status: **Private**
 * @module nmodule/vykonPro/rc/binding/EnhancedValueBinding
 */
define(['baja!', 'Promise', 'nmodule/bajaui/rc/baja/binding/Binding', 'nmodule/bajaui/rc/binding/impl/widgetEvents', 'nmodule/bajaui/rc/baja/binding/ValueBinding', 'css!nmodule/vykonPro/rc/vykonPro'], function (baja, Promise, Binding, widgetEvents, ValueBinding) {
  'use strict'; //const logSevere = log.severe.bind(log);

  /**
   * BajaScript implementation of `vykonPro:EnhancedValueBinding`.
   * @class
   * @alias module:nmodule/kitPx/rc/binding/BoundLabelBinding
   * @extends module:nmodule/bajaui/rc/baja/binding/ValueBinding
   */

  return /*#__PURE__*/function (_ValueBinding) {
    _inherits(EnhancedValueBinding, _ValueBinding);

    var _super = _createSuper(EnhancedValueBinding);

    function EnhancedValueBinding() {
      _classCallCheck(this, EnhancedValueBinding);

      return _super.apply(this, arguments);
    }

    _createClass(EnhancedValueBinding, [{
      key: "$formatHyperlink",
      value:
      /**
       * - `hyperlinkFormat`: resolved against ordTarget to set hyperlink property
       */
      function $formatHyperlink() {
        return this.get('hyperlinkFormat').format({
          object: this.getOrdTarget().getObject()
        }).then(baja.Ord.make);
      }
    }, {
      key: "targetChanged",
      value: function targetChanged() {
        var _this = this;

        return this.$formatHyperlink().then(function (hyperlink) {
          _this.getWidget().jq().toggleClass('hyperlink-target', hyperlink && !hyperlink.isNull());

          return _this.set({
            slot: 'hyperlink',
            value: hyperlink
          });
        }).then(function () {
          return _get(_getPrototypeOf(EnhancedValueBinding.prototype), "targetChanged", _this).call(_this);
        });
      }
    }]);

    return EnhancedValueBinding;
  }(ValueBinding);
});
